diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
index a709f569e..bb68f8bda 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
@@ -59,11 +59,11 @@ public class DensityGeneratorNether
         this.poolNoiseUnder = new PerlinSimplexNoise(rand, 1);
 
         densityGeneratorMap.put(Biomes.NETHER_NETHER, this::generateDensityMapBiomeNether);
-        densityGeneratorMap.put(Biomes.NETHER_VOLCANIC_ISLANDS, this::generateDensityMapBiomeVolcanicIslands);
-        densityGeneratorMap.put(Biomes.NETHER_SULFUR_POOLS, this::generateDensityMapBiomeSulphurPools);
-        densityGeneratorMap.put(Biomes.NETHER_CRYSTAL_FOREST, this::generateDensityMapOcean);
-        densityGeneratorMap.put(Biomes.NETHER_ASH_PLAINS, this::generateDensityMapBiomeTest);
-        densityGeneratorMap.put(Biomes.NETHER_BONEYARD, this::generateDensityMapBiomeTest);
+        densityGeneratorMap.put(Biomes.NETHER_VOLCANIC_ISLANDS, this::generateDensityMapBiomeNether);
+        densityGeneratorMap.put(Biomes.NETHER_SULFUR_POOLS, this::generateDensityMapBiomeNether);
+        densityGeneratorMap.put(Biomes.NETHER_CRYSTAL_FOREST, this::generateDensityMapBiomeNether);
+        densityGeneratorMap.put(Biomes.NETHER_ASH_PLAINS, this::generateDensityMapBiomeNether);
+        densityGeneratorMap.put(Biomes.NETHER_BONEYARD, this::generateDensityMapBiomeNether);
     }
 
     @Override
@@ -79,7 +79,8 @@ public class DensityGeneratorNether
         int y = 0;
         int z = chunk.zPosition * 4;
 
-        int halfYSize = ((terrainHeight / 2) / 8) + 1;
+        int quarterYSize = ((terrainHeight / 4) / 8) + 1;
+        int threeQuarterYSize = ((int) (terrainHeight * 0.75f) / 8) + 1;
 
         double[] densityMapArray = new double[xSize * ySize * zSize];
         Map<Biome, double[]> perBiomeDensityMaps = new HashMap<>();
@@ -98,11 +99,11 @@ public class DensityGeneratorNether
                 biomeProvider.getOverlap(temperature, overlapPair);
 
                 if (!perBiomeDensityMaps.containsKey(overlapPair.biomeA)) {
-                    perBiomeDensityMaps.put(overlapPair.biomeA, densityGeneratorMap.get(overlapPair.biomeA).generateDensityMap(chunk, terrainHeight / 2, xSize, halfYSize, zSize, x, y, z));
+                    perBiomeDensityMaps.put(overlapPair.biomeA, densityGeneratorMap.get(overlapPair.biomeA).generateDensityMap(chunk, (int) (terrainHeight * 0.75f), xSize, threeQuarterYSize, zSize, x, y, z));
                 }
                 if (overlapPair.hasOverlap) {
                     if (!perBiomeDensityMaps.containsKey(overlapPair.biomeB)) {
-                        perBiomeDensityMaps.put(overlapPair.biomeB, densityGeneratorMap.get(overlapPair.biomeB).generateDensityMap(chunk, terrainHeight / 2, xSize, halfYSize, zSize, x, y, z));
+                        perBiomeDensityMaps.put(overlapPair.biomeB, densityGeneratorMap.get(overlapPair.biomeB).generateDensityMap(chunk, (int) (terrainHeight * 0.75f), xSize, threeQuarterYSize, zSize, x, y, z));
                     }
                 }
             }
@@ -119,15 +120,15 @@ public class DensityGeneratorNether
                 }
 
                 if (densityMapB != null) {
-                    for (int dy = 0; dy < halfYSize; dy++) {
-                        double densityA = densityMapA[(dx * zSize * halfYSize) + (dz * halfYSize) + dy];
-                        double densityB = densityMapB[(dx * zSize * halfYSize) + (dz * halfYSize) + dy];
-                        densityMapArray[(dx * zSize * ySize) + (dz * ySize) + (dy + halfYSize - 1)] = MathHelper.lerp(densityA, densityB, overlapPair.biomeBPercentage);
+                    for (int dy = 0; dy < threeQuarterYSize; dy++) {
+                        double densityA = densityMapA[(dx * zSize * threeQuarterYSize) + (dz * threeQuarterYSize) + dy];
+                        double densityB = densityMapB[(dx * zSize * threeQuarterYSize) + (dz * threeQuarterYSize) + dy];
+                        densityMapArray[(dx * zSize * ySize) + (dz * ySize) + (dy + quarterYSize - 1)] = MathHelper.lerp(densityA, densityB, overlapPair.biomeBPercentage);
                     }
                 } else {
-                    for (int dy = 0; dy < halfYSize; dy++) {
-                        double densityA = densityMapA[(dx * zSize * halfYSize) + (dz * halfYSize) + dy];
-                        densityMapArray[(dx * zSize * ySize) + (dz * ySize) + (dy + halfYSize - 1)] = densityA;
+                    for (int dy = 0; dy < threeQuarterYSize; dy++) {
+                        double densityA = densityMapA[(dx * zSize * threeQuarterYSize) + (dz * threeQuarterYSize) + dy];
+                        densityMapArray[(dx * zSize * ySize) + (dz * ySize) + (dy + quarterYSize - 1)] = densityA;
                     }
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 03772c650..648d7f637 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -5,9 +5,12 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
+import net.minecraft.core.world.noise.PerlinNoise;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.HashMap;
 import java.util.Map;
@@ -17,14 +20,18 @@ public class TerrainGeneratorNether
 {
     private final DensityGenerator densityGenerator;
 
-    private int lastX = -1;
-    private int lastZ = -1;
+    private int lastX = Integer.MIN_VALUE;
+    private int lastZ = Integer.MIN_VALUE;
     private Biome lastBiome = null;
     private Biome lastBiomeNegX = null;
     private Biome lastBiomePosX = null;
     private Biome lastBiomeNegZ = null;
     private Biome lastBiomePosZ = null;
     private Map<Biome, Integer> fluidLookup = new HashMap<>();
+    private int lastChunkX = Integer.MIN_VALUE;
+    private int lastChunkZ = Integer.MIN_VALUE;
+    private final @NotNull PerlinNoise noise = new PerlinNoise(0L, 4, 0);
+    private final double @NotNull [] cache = new double[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z * (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y)];
 
     public TerrainGeneratorNether(World world)
     {
@@ -66,11 +73,23 @@ public class TerrainGeneratorNether
                 lastBiomePosZ = chunk.getBlockBiome(x, 0, z + 1);
             }
         }
+        if (lastChunkX != chunk.xPosition || lastChunkZ != chunk.zPosition) {
+            lastChunkX = chunk.xPosition;
+            lastChunkZ = chunk.zPosition;
+            noise.get(cache, chunk.xPosition * Chunk.CHUNK_SIZE_X, 0, chunk.zPosition * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, 0.2, 0.2, 0.2);
+
+            float avg = 0;
+            for (int i = 0; i < cache.length; i++) {
+                avg += cache[i];
+            }
+            avg /= cache.length;
+            System.out.println("avg: " + avg);
+        }
 
         WorldType type = world.getWorldType();
-        int halfHeight = type.getMaxY() / 2;
+        int quarterHeight = type.getMaxY() / 4;
 
-        if (y < halfHeight)
+        if (y < quarterHeight)
         {
             return 0;
         }
@@ -78,7 +97,7 @@ public class TerrainGeneratorNether
         {
             return Blocks.BEDROCK.id();
         }
-//        else if (y >= halfHeight - rand.nextInt(5) && y <= halfHeight + 5 - rand.nextInt(5))
+//        else if (y >= quarterHeight - rand.nextInt(5) && y <= quarterHeight + 5 - rand.nextInt(5))
 //        {
 //            return Blocks.BEDROCK.id();
 //        }
@@ -86,19 +105,29 @@ public class TerrainGeneratorNether
 //        {
 //            return Blocks.BEDROCK.id();
 //        }
-//        else if (y <= halfHeight)
+//        else if (y <= quarterHeight)
 //        {
 //            return Blocks.SOULSCHIST.id();
 //        }
-        else if (y <= halfHeight + rand.nextInt(5))
+        else if (y <= quarterHeight + rand.nextInt(5))
         {
             return Blocks.BEDROCK.id();
         }
         else if (density > 0.0)
         {
+            if (lastBiome == Biomes.NETHER_CRYSTAL_FOREST) {
+                int sizeY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
+                // YZX ordering
+                final double d = ((cache[(x * Chunk.CHUNK_SIZE_Z * sizeY) + (z * sizeY) + y]));
+                if (d > 0 && d < 2) {
+                    return Blocks.CRYSTAL.id();
+                } else if (d > -1 && d < 3) {
+                    return Blocks.COBBLE_NETHERRACK_MOSSY.id();
+                }
+            }
             return type.getFillerBlockId();
         }
-        else if (y >= halfHeight && y < type.getOceanY())
+        else if (y >= quarterHeight && y < type.getOceanY())
         {
             int biomeFluid = fluidLookup.getOrDefault(lastBiome, 0);
             int biomeFluidNegX = fluidLookup.getOrDefault(lastBiomeNegX, 0);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
new file mode 100644
index 000000000..432c9a201
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
@@ -0,0 +1,321 @@
+package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
+
+import net.minecraft.core.block.BlockLogicSand;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+import net.minecraft.core.world.generate.feature.*;
+import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.type.WorldTypes;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class ChunkDecoratorOverworldB173
+    implements ChunkDecorator
+{
+    private final @NotNull World world;
+    private final @NotNull PerlinNoise forestNoise;
+
+    public ChunkDecoratorOverworldB173(final @NotNull World world) {
+        this.world = world;
+
+        this.forestNoise = new PerlinNoise(world.getRandomSeed(), 8, 82);
+    }
+
+    @Override
+    public void decorate(final Chunk chunk) {
+        this.world.scheduledUpdatesAreImmediate = true;
+        BlockLogicSand.fallInstantly = true;
+
+        final int x = chunk.xPosition;
+        final int z = chunk.zPosition;
+
+        final int minY = this.world.getWorldType().getMinY();
+        final int maxY = this.world.getWorldType().getMaxY();
+        final int rangeY = (maxY + 1) - minY;
+
+        final int wx = x * 16;
+        final int wz = z * 16;
+
+        final @NotNull Biome biome = this.world.getBlockBiome(wx, 0, wz);
+
+        final @NotNull Random rand = new Random(this.world.getRandomSeed());
+
+        final long rx = rand.nextLong() / 2L * 2L + 1L;
+        final long rz = rand.nextLong() / 2L * 2L + 1L;
+
+        rand.setSeed(rx * x + rz * z ^ this.world.getRandomSeed());
+
+        if (rand.nextInt(4) == 0) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureLake(Blocks.FLUID_WATER_STILL.id()).place(this.world, rand, fx, fy, fz);
+        }
+
+        if (rand.nextInt(8) == 0) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            if (fy < rangeY / 2 || rand.nextInt(10) == 0) {
+                new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id()).place(this.world, rand, fx, fy, fz);
+            }
+        }
+
+        for (int i = 0; i < 8; i++) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureDungeon(Blocks.COBBLE_STONE.id(), Blocks.COBBLE_STONE_MOSSY.id(), null).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 10; i++) {
+            final int fx = wx + rand.nextInt(16);
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16);
+            new WorldFeatureClay(32).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 20; i++) {
+            final int fx = wx + rand.nextInt(16);
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16);
+            new WorldFeatureOre(Blocks.DIRT.id(), 32).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 10; i++) {
+            final int fx = wx + rand.nextInt(16);
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16);
+            new WorldFeatureOre(Blocks.GRAVEL.id(), 32).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 20; i++) {
+            final int fx = wx + rand.nextInt(16);
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16);
+            new WorldFeatureOre(Blocks.ORE_COAL_STONE.id(), 16).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 20; i++) {
+            final int fx = wx + rand.nextInt(16);
+            final int fy = rand.nextInt(rangeY / 2);
+            final int fz = wz + rand.nextInt(16);
+            new WorldFeatureOre(Blocks.ORE_IRON_STONE.id(), 8).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 2; i++) {
+            final int fx = wx + rand.nextInt(16);
+            final int fy = rand.nextInt(rangeY / 4);
+            final int fz = wz + rand.nextInt(16);
+            new WorldFeatureOre(Blocks.ORE_GOLD_STONE.id(), 8).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 8; i++) {
+            final int fx = wx + rand.nextInt(16);
+            final int fy = rand.nextInt(rangeY / 8);
+            final int fz = wz + rand.nextInt(16);
+            new WorldFeatureOre(Blocks.ORE_REDSTONE_STONE.id(), 7).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 1; i++) {
+            final int fx = wx + rand.nextInt(16);
+            final int fy = rand.nextInt(rangeY / 16);
+            final int fz = wz + rand.nextInt(16);
+            new WorldFeatureOre(Blocks.ORE_DIAMOND_STONE.id(), 7).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 1; i++) {
+            final int fx = wx + rand.nextInt(16);
+            final int fy = rand.nextInt(rangeY / 16) + rand.nextInt(rangeY / 16);
+            final int fz = wz + rand.nextInt(16);
+            new WorldFeatureOre(Blocks.ORE_LAPIS_STONE.id(), 6).place(this.world, rand, fx, fy, fz);
+        }
+
+        final double forestNoiseScale = 0.5;
+        final int forestNoiseValue = (int) ((this.forestNoise.get(wx * forestNoiseScale, wz * forestNoiseScale) / 8.0 + rand.nextDouble() * 4.0 + 4.0) / 3.0);
+        int numTrees = 0;
+
+        if (rand.nextInt(10) == 0) {
+            numTrees++;
+        }
+
+        if (biome == Biomes.OVERWORLD_LEGACY_FOREST) {
+            numTrees += forestNoiseValue + 5;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_RAINFOREST) {
+            numTrees += forestNoiseValue + 5;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_SEASONAL_FOREST) {
+            numTrees += forestNoiseValue + 2;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_TAIGA) {
+            numTrees += forestNoiseValue + 5;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_DESERT) {
+            numTrees -= 20;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_TUNDRA) {
+            numTrees -= 20;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_PLAINS) {
+            numTrees -= 20;
+        }
+
+        for (int i = 0; i < numTrees; i++) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fz = wz + rand.nextInt(16) + 8;
+            final @NotNull WorldFeature feature = biome.getRandomWorldGenForTrees(rand);
+            feature.init(1.0, 1.0, 1.0);
+            biome.getRandomWorldGenForTrees(rand).place(this.world, rand, fx, this.world.getHeightValue(fx, fz), fz);
+        }
+
+        int numYellowFlowers = 0;
+        if (biome == Biomes.OVERWORLD_LEGACY_FOREST) {
+            numYellowFlowers += 2;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_SEASONAL_FOREST) {
+            numYellowFlowers += 4;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_TAIGA) {
+            numYellowFlowers += 2;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_PLAINS) {
+            numYellowFlowers += 3;
+        }
+
+        for (int i = 0; i < numYellowFlowers; i++) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id(), 64, false).place(this.world, rand, fx, fy, fz);
+        }
+
+        int numPlants = 0;
+        if (biome == Biomes.OVERWORLD_LEGACY_FOREST) {
+            numPlants += 2;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_RAINFOREST) {
+            numPlants += 10;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_SEASONAL_FOREST) {
+            numPlants += 2;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_TAIGA) {
+            numPlants += 1;
+        }
+        if (biome == Biomes.OVERWORLD_LEGACY_PLAINS) {
+            numPlants += 10;
+        }
+
+        for (int i = 0; i < numPlants; i++) {
+            int plantBlockId = Blocks.TALLGRASS.id();
+            if (biome == Biomes.OVERWORLD_LEGACY_RAINFOREST && rand.nextInt(3) != 0) {
+                plantBlockId = Blocks.TALLGRASS_FERN.id();
+            }
+
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureTallGrass(plantBlockId).place(this.world, rand, fx, fy, fz);
+        }
+
+        int numDeadBushes = 0;
+        if (biome == Biomes.OVERWORLD_LEGACY_DESERT) {
+            numDeadBushes += 2;
+        }
+
+        for (int i = 0; i < numDeadBushes; i++) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureDeadBush(Blocks.DEADBUSH.id()).place(this.world, rand, fx, fy, fz);
+        }
+
+        if (rand.nextInt(2) == 0) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureFlowers(Blocks.FLOWER_RED.id(), 64, false).place(this.world, rand, fx, fy, fz);
+        }
+
+        if (rand.nextInt(4) == 0) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureFlowers(Blocks.MUSHROOM_BROWN.id(), 64, false).place(this.world, rand, fx, fy, fz);
+        }
+
+        if (rand.nextInt(8) == 0) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureFlowers(Blocks.MUSHROOM_RED.id(), 64, false).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 10; i++) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureSugarCane().place(this.world, rand, fx, fy, fz);
+        }
+
+        if (rand.nextInt(32) == 0) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeaturePumpkin().place(this.world, rand, fx, fy, fz);
+        }
+
+        int numCacti = 0;
+        if (biome == Biomes.OVERWORLD_LEGACY_DESERT) {
+            numCacti += 10;
+        }
+
+        for (int i = 0; i < numCacti; i++) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureCactus().place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 50; i++) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id()).place(this.world, rand, fx, fy, fz);
+        }
+
+        for (int i = 0; i < 20; i++) {
+            final int fx = wx + rand.nextInt(16) + 8;
+            final int fy = rand.nextInt(rangeY);
+            final int fz = wz + rand.nextInt(16) + 8;
+            new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id()).place(this.world, rand, fx, fy, fz);
+        }
+
+        final int oceanY = this.world.getWorldType().getOceanY();
+        for(int xx = x + 8; xx < x + 8 + 16; xx++) {
+            for(int zz = z + 8; zz < z + 8 + 16; zz++) {
+                int yy = this.world.getHeightValue(xx, zz);
+                final Biome localBiome = this.world.getBlockBiome(xx, yy, zz);
+
+                if (localBiome.hasSurfaceSnow() && yy > 0 && yy < this.world.getHeightBlocks()) {
+                    if (this.world.isAirBlock(xx, yy, zz) && this.world.getBlockMaterial(xx, yy - 1, zz).blocksMotion()) {
+                        this.world.setBlockWithNotify(xx, yy, zz, Blocks.LAYER_SNOW.id());
+                    }
+                }
+                if (localBiome.hasSurfaceSnow() && (this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_FLOWING.id())) {
+                    this.world.setBlockWithNotify(xx, oceanY - 1, zz, Blocks.ICE.id());
+                }
+            }
+        }
+
+        BlockLogicSand.fallInstantly = false;
+        this.world.scheduledUpdatesAreImmediate = false;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkGeneratorOverworldB173.java
new file mode 100644
index 000000000..47f280c6e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkGeneratorOverworldB173.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.CavesLargeFeature;
+import net.minecraft.core.world.generate.LargeFeature;
+import net.minecraft.core.world.generate.RetroCavesLargeFeature;
+import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
+
+public class ChunkGeneratorOverworldB173
+    extends ChunkGeneratorPerlin
+{
+    public ChunkGeneratorOverworldB173(World world) {
+        super(world,
+              new ChunkDecoratorOverworldB173(world),
+              new TerrainGeneratorOverworldB173(world),
+              new SurfaceGeneratorOverworldB173(world),
+              new LargeFeature[] { new RetroCavesLargeFeature(world.getWorldType().getMinY(), world.getWorldType().getMaxY() + 1) }
+        );
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
new file mode 100644
index 000000000..1d8d47db3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
@@ -0,0 +1,21 @@
+package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.chunk.perlin.overworld.DensityGeneratorOverworld;
+import net.minecraft.core.world.noise.BetaPerlinNoise;
+
+public class DensityGeneratorOverworldB173
+    extends DensityGeneratorOverworld
+{
+
+    public DensityGeneratorOverworldB173(final World world) {
+        super(world,
+            new BetaPerlinNoise(world.getRandomSeed(), 16, 0),
+            new BetaPerlinNoise(world.getRandomSeed(), 16, 16),
+            new BetaPerlinNoise(world.getRandomSeed(), 8, 32),
+            new BetaPerlinNoise(world.getRandomSeed(), 10, 48),
+            new BetaPerlinNoise(world.getRandomSeed(), 16, 58),
+            false
+        );
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java
new file mode 100644
index 000000000..dff75eae1
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java
@@ -0,0 +1,18 @@
+package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
+import net.minecraft.core.world.noise.BetaPerlinNoise;
+
+public class SurfaceGeneratorOverworldB173
+    extends SurfaceGeneratorOverworld
+{
+    public SurfaceGeneratorOverworldB173(final World world) {
+        super(world,
+            new BetaPerlinNoise(world.getRandomSeed(), 4, 40),
+            new BetaPerlinNoise(world.getRandomSeed(), 4, 44),
+            new BetaPerlinNoise(world.getRandomSeed(), 8, 32),
+            false
+        );
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/TerrainGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/TerrainGeneratorOverworldB173.java
new file mode 100644
index 000000000..d8de84463
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/TerrainGeneratorOverworldB173.java
@@ -0,0 +1,14 @@
+package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.chunk.perlin.overworld.TerrainGeneratorOverworld;
+
+public class TerrainGeneratorOverworldB173
+    extends TerrainGeneratorOverworld
+{
+    public TerrainGeneratorOverworldB173(final World world) {
+        super(world,
+            new DensityGeneratorOverworldB173(world)
+        );
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/floating/ChunkGeneratorOverworldFloating.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/floating/ChunkGeneratorOverworldFloating.java
index dc3009002..0308cc9ec 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/floating/ChunkGeneratorOverworldFloating.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/floating/ChunkGeneratorOverworldFloating.java
@@ -6,13 +6,13 @@ import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.ChunkDecoratorOverworld;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
-import net.minecraft.core.world.generate.chunk.perlin.paradise.TerrainGeneratorParadise;
+import net.minecraft.core.world.generate.chunk.perlin.drift.TerrainGeneratorDrift;
 
 public class ChunkGeneratorOverworldFloating
     extends ChunkGeneratorPerlin
 {
     public ChunkGeneratorOverworldFloating(World world)
     {
-        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorParadise(world), new SurfaceGeneratorOverworld(world), new LargeFeature[] { new CavesLargeFeature() });
+        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorDrift(world), new SurfaceGeneratorOverworld(world), new LargeFeature[] { new CavesLargeFeature() });
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java
index fe6ec3396..2ec4add36 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkGeneratorOverworldRetro.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld.retro;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.CavesLargeFeature;
 import net.minecraft.core.world.generate.LargeFeature;
+import net.minecraft.core.world.generate.RetroCavesLargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
 
 public class ChunkGeneratorOverworldRetro
@@ -15,7 +16,7 @@ public class ChunkGeneratorOverworldRetro
               new ChunkDecoratorOverworldRetro(world),
               new TerrainGeneratorOverworldRetro(world),
               new SurfaceGeneratorOverworldRetro(world),
-              new LargeFeature[] { new CavesLargeFeature() }
+              new LargeFeature[] { new RetroCavesLargeFeature(world.getWorldType().getMinY(), world.getWorldType().getMaxY() + 1) }
         );
     }
 }
